#ifndef PAGER_LIB_H
#include "/pager_lib.h"
#endif

APTR AllocPagerHandle(STRPTR logProgram);
void FreePagerHandle(APTR handle);
void ULogA(APTR handle, LONG level, STRPTR fmt, LONG *args);
void ULog(APTR handle, LONG level, STRPTR fmt, ...);
void SetLogLevel(APTR handle, LONG level);
void SetLogService(APTR handle, STRPTR serviceName);
void SetLogWho(APTR handle, STRPTR whoName);
BOOL LockFile(APTR handle, STRPTR fileName);
void UnLockFile(APTR handle, STRPTR fileName);
void UnLockFiles(APTR handle);
STRPTR FindPagerConfig(APTR handle, STRPTR configEntryName);
STRPTR FindPagerConfigDefault(APTR handle, STRPTR configEntryName, STRPTR defaultValue);
STRPTR FreePagerConfig(STRPTR configEntry);
BOOL PagerConfigYesNo(STRPTR configEntry);
PagerService_t *FindPagerService(APTR handle, STRPTR serviceName);
void FreePagerService(PagerService_t *service);
PagerAlias_t *FindPagerAlias(APTR handle, STRPTR aliasName);
void FreePagerAlias(PagerAlias_t *alias);
LONG GetSequenceNumber(APTR handle, UWORD increment);
STRPTR SequenceToName(STRPTR buffer, LONG sequence);
STRPTR NameInSpool(APTR handle, STRPTR name);
void FreeNameInSpool(STRPTR name);
